% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multi_gene_z_score.R
\name{multi_gene_z_score}
\alias{multi_gene_z_score}
\title{Combine multiple continuous variables by averaging Z scores}
\usage{
multi_gene_z_score(cont_mat)
}
\arguments{
\item{cont_mat}{A \code{matrix()} with spots as rows and 2 or more continuous
variables as columns.}
}
\value{
A \code{numeric()} vector with one element per spot, summarizing the
multiple continuous variables.
}
\description{
To summarize multiple features, each is normalized to represent a Z-score.
Scores are averaged to return a single vector.
}
\seealso{
Other functions for summarizing expression of multiple continuous variables simultaneously: 
\code{\link{multi_gene_pca}()},
\code{\link{multi_gene_sparsity}()}
}
\author{
Nicholas J. Eagles
}
\concept{functions for summarizing expression of multiple continuous variables simultaneously}
\keyword{internal}
